Build a Flutter App (iOS)

  • POST
  • /workspaces
  • /:workspace
  • /projects
  • /:project_name
  • /pipelines
  • /:pipeline_id
  • /actions

Creates a new Build a Flutter App (iOS) action in the pipeline

Request

REQUIRED SCOPES
EXECUTION_MANAGE
URL PARAMETERS
workspacerequiredstring
The human-readable ID of the workspace

Example: "my-company"

project_namerequiredstring
The human-readable ID of the project

Example: "my-project"

pipeline_idrequiredinteger
The ID of the pipeline

Example: 123

POST PARAMETERS
typerequiredstring enum
The type of the action
Allowed enum:
NATIVE_BUILD_MAC_FLUTTER
urlread-onlystring
API endpoint to GET this object
html_urlread-onlystring
Web URL to view this object in Buddy.works
after_action_idinteger
The numerical ID of the action, after which this action should be added
namerequiredstring
The name of the action
trigger_timestring enum
Specifies when the action should be executed
Allowed enum:
ON_EVERY_EXECUTION,
ON_SUCCESS,
ON_FAILURE,
ON_BACK_TO_SUCCESS,
ON_WARNING,
ON_WAIT_FOR_APPROVE,
ON_TERMINATE
trigger_conditionsTriggerConditionView[]
The list of trigger conditions to meet so that the action can be triggered
run_nextstring enum
Defines whether the action should run in parallel with the next one
Allowed enum:
WAIT_ON_SUCCESS,
IN_SOFT_PARALLEL,
IN_HARD_PARALLEL
run_only_on_first_failureboolean
Defines whether the action should be executed on each failure. Restricted to and required if the trigger_time is ON_FAILURE
variablesEnvironmentVariableView[]
The list of variables you can use the action
disabledboolean
When set to true the action is disabled. By default it is set to false
timeoutinteger
The timeout in seconds
ignore_errorsboolean
If set to true the execution will proceed, mark action as a warning and jump to the next action. Doesn't apply to deployment actions
retry_countinteger
Number of retries if the action fails
retry_intervalinteger
Delay time between auto retries in seconds
loopstring[]
The list of commands that will be executed in a loop
current_revisionstring
The git revision of the last successful run of the action
permissionsPermissionsView
Access permissions configuration
working_directorystring
The directory in which the pipeline filesystem will be mounted
execute_every_commandboolean
If set to true all commands will be executed regardless of the result of the previous command
commandsstring[]
The commands to execute in the native build environment
deployment_excludesstring[]
The list of files or directories to exclude from deployment
vm_from_prev_actionboolean
If set to true, the VM from the previous action will be used
vm_action_idinteger
The ID of the action from which the VM will be used
vm_action_namestring
The name of the action from which the VM will be used
instance_typestring enum
The type of instance to use for the native build
Allowed enum:
GENERAL_MEDIUM,
GENERAL_LARGE,
GENERAL_XLARGE,
GENERAL_2XLARGE,
COMPUTE_MEDIUM,
COMPUTE_LARGE,
COMPUTE_XLARGE,
COMPUTE_2XLARGE,
ARM_GENERAL_MEDIUM,
ARM_GENERAL_LARGE,
ARM_GENERAL_XLARGE,
ARM_GENERAL_2XLARGE,
ARM_COMPUTE_MEDIUM,
ARM_COMPUTE_LARGE,
ARM_COMPUTE_XLARGE,
ARM_COMPUTE_2XLARGE
xcode_versionstring
The version of Xcode to use
pre_start_simulatorsstring[]
The list of simulators to start before the build
node_versionstring
The version of Node.js to use
flutter_versionstring
The version of Flutter to use
archive_locationstring
The path to the archive location
certificatesstring[]
The list of certificates to use for signing
provision_profilesstring[]
The list of provisioning profiles to use
sign_modestring enum
The signing mode
Allowed enum:
MANUAL,
AUTOMATIC
distribution_methodstring enum
The distribution method
Allowed enum:
APP_STORE,
AD_HOC,
DEVELOPMENT,
ENTERPRISE
export_locationstring
The path to export the signed app
property_list_sourcestring enum
The source of the property list
Allowed enum:
GENERATED,
PIPELINE_VOLUME,
VARIABLE,
ACTION
property_liststring
The content of the property list
validate_before_uploadboolean
If set to true, the app will be validated before upload
submit_for_reviewboolean
If set to true, the app will be submitted for review
skip_metadataboolean
If set to true, metadata will not be uploaded
skip_app_version_updateboolean
If set to true, the app version will not be updated
skip_screenshotsboolean
If set to true, screenshots will not be uploaded
sync_pathsSyncPathView[]
Define file paths that should be copied before (PIPELINE_TO_VM) and after the execution (VM_TO_PIPELINE).
shellstring enum
The name of the shell that will be used to execute commands
Allowed enum:
SH,
BASH,
POWERSHELL

Response

RESPONSE BODY
typestring enum
The type of the action
Allowed enum:
NATIVE_BUILD_MAC_FLUTTER
urlread-onlystring
API endpoint to GET this object
html_urlread-onlystring
Web URL to view this object in Buddy.works
idinteger
The ID of the action
namestring
The name of the action
current_revisionstring
The git revision of the last successful run of the action
trigger_timestring enum
Specifies when the action should be executed
Allowed enum:
ON_EVERY_EXECUTION,
ON_SUCCESS,
ON_FAILURE,
ON_BACK_TO_SUCCESS,
ON_WARNING,
ON_WAIT_FOR_APPROVE,
ON_TERMINATE
trigger_conditionsTriggerConditionView[]
The list of trigger conditions to meet so that the action can be triggered
run_nextstring enum
Defines whether the action should run in parallel with the next one
Allowed enum:
WAIT_ON_SUCCESS,
IN_SOFT_PARALLEL,
IN_HARD_PARALLEL
run_only_on_first_failureboolean
Defines whether the action should be executed on each failure. Restricted to and required if the trigger_time is ON_FAILURE
variablesEnvironmentVariableView[]
The list of variables you can use the action
disabledboolean
When set to true the action is disabled. By default it is set to false
timeoutinteger
The timeout in seconds
ignore_errorsboolean
If set to true the execution will proceed, mark action as a warning and jump to the next action. Doesn't apply to deployment actions
retry_countinteger
Number of retries if the action fails
retry_intervalinteger
Delay time between auto retries in seconds
last_execution_statusstring enum
The status of the last run of the action
Allowed enum:
INPROGRESS,
ENQUEUED,
TERMINATED,
SUCCESSFUL,
FAILED,
INITIAL,
NOT_EXECUTED,
SKIPPED,
TERMINATING,
WAITING_FOR_APPLY,
WAITING_FOR_VARIABLES,
WAITING_FOR_SETTABLE_VARIABLES,
WAITING_FOR_VT_SESSION
pipelineShortPipelineView
Short representation of a pipeline
permissionsPermissionsView
Access permissions configuration
loopstring[]
The list of commands that will be executed in a loop
working_directorystring
The directory in which the pipeline filesystem will be mounted
execute_every_commandboolean
If set to true all commands will be executed regardless of the result of the previous command
commandsstring[]
The commands to execute in the native build environment
deployment_excludesstring[]
The list of files or directories to exclude from deployment
vm_from_prev_actionboolean
If set to true, the VM from the previous action will be used
vm_action_idinteger
The ID of the action from which the VM will be used
vm_action_namestring
The name of the action from which the VM will be used
instance_typestring enum
The type of instance to use for the native build
Allowed enum:
GENERAL_MEDIUM,
GENERAL_LARGE,
GENERAL_XLARGE,
GENERAL_2XLARGE,
COMPUTE_MEDIUM,
COMPUTE_LARGE,
COMPUTE_XLARGE,
COMPUTE_2XLARGE,
ARM_GENERAL_MEDIUM,
ARM_GENERAL_LARGE,
ARM_GENERAL_XLARGE,
ARM_GENERAL_2XLARGE,
ARM_COMPUTE_MEDIUM,
ARM_COMPUTE_LARGE,
ARM_COMPUTE_XLARGE,
ARM_COMPUTE_2XLARGE
xcode_versionstring
The version of Xcode to use
pre_start_simulatorsstring[]
The list of simulators to start before the build
node_versionstring
The version of Node.js to use
flutter_versionstring
The version of Flutter to use
archive_locationstring
The path to the archive location
certificatesstring[]
The list of certificates to use for signing
provision_profilesstring[]
The list of provisioning profiles to use
sign_modestring enum
The signing mode
Allowed enum:
MANUAL,
AUTOMATIC
distribution_methodstring enum
The distribution method
Allowed enum:
APP_STORE,
AD_HOC,
DEVELOPMENT,
ENTERPRISE
export_locationstring
The path to export the signed app
property_list_sourcestring enum
The source of the property list
Allowed enum:
GENERATED,
PIPELINE_VOLUME,
VARIABLE,
ACTION
property_liststring
The content of the property list
validate_before_uploadboolean
If set to true, the app will be validated before upload
submit_for_reviewboolean
If set to true, the app will be submitted for review
skip_metadataboolean
If set to true, metadata will not be uploaded
skip_app_version_updateboolean
If set to true, the app version will not be updated
skip_screenshotsboolean
If set to true, screenshots will not be uploaded
sync_pathsSyncPathView[]
Define file paths that should be copied before (PIPELINE_TO_VM) and after the execution (VM_TO_PIPELINE).
shellstring enum
The name of the shell that will be used to execute commands
Allowed enum:
SH,
BASH,
POWERSHELL

Last modified on Mar 18, 2026

Request example

curl -X POST "https://api.buddy.works/workspaces/:workspace/projects/:project_name/pipelines/:pipeline_id/actions" \ -H "Authorization: Bearer <YOUR-TOKEN>" \ -H "Content-Type: application/json" \ -d '{ "name": "Build application", "type": "NATIVE_BUILD_MAC_FLUTTER", "trigger_time": "ON_EVERY_EXECUTION", "working_directory": "/Users/buddy/build", "commands": [ "flutter build ios --release" ], "execute_every_command": true, "sync_paths": [ { "pipeline_path": "/", "vm_path": "/Users/buddy/build", "direction": "PIPELINE_TO_VM" }, { "pipeline_path": "/", "vm_path": "/Users/buddy/build", "direction": "VM_TO_PIPELINE" } ], "node_version": "14", "xcode_version": "13", "pre_start_simulators": [ "iPhone 13 Pro Max" ], "certificates": [ "myCert" ], "provision_profiles": [ "myProfile" ] }'
STATUS
200 OK